<script lang="ts" setup>
import { ref, onMounted, watch, computed, nextTick } from "vue";
import CodeOpen from "./code-open.vue";
import CodeClose from "./code-close.vue";
import CodeCopy from "./code-copy.vue";
import { useNameSpace } from "./use-namespaces";
import { useCodeFold } from "./use-codefold";
import { useCodeCopy } from "./use-codecopy";
import { MessageNoticeService } from "./messages/index";

interface DemoBlockProps {
  code: string;
  showCode: string;
  title: string;
  description: string;
}

const props = withDefaults(defineProps<DemoBlockProps>(), {
  title: "默认标题",
  description: "描述内容",
});

const ns = useNameSpace();
const { isCodeFold, setCodeFold } = useCodeFold();
const { copyContent, clickCopy } = useCodeCopy();

const sourceCode = ref(decodeURIComponent(props.code));
const showSourceCode = ref(decodeURIComponent(props.showCode));
const height = ref(0);
const sourceCodeArea = ref<any>(null);

const clickCodeCopy = () => {
  clickCopy(sourceCode.value);
  MessageNoticeService.open();
};

onMounted(() => {
  nextTick(() => {
    height.value = sourceCodeArea.value?.clientHeight ?? 0;
  })
});

</script>

<template>
  <ClientOnly>
    <div :class="[ns.e('ant-design__container')]">
      <section :class="[ns.bem('preview')]">
        <slot> </slot>
      </section>
      <section :class="[ns.bem('description')]">
        <div v-if="props.title" :class="[ns.bem('description', 'title')]">
          {{ title }}
        </div>
        <div
          v-if="props.description"
          :class="[ns.bem('description', 'content')]"
          v-html="description"
        ></div>
        <div
          v-if="props.description || (!props.title && !props.description)"
          :class="[ns.bem('description', 'split-line')]"
        ></div>
        <div :class="[ns.bem('description', 'handle-btn')]">
          <CodeClose v-if="!isCodeFold" @click="setCodeFold(true)" />
          <CodeOpen v-else @click="setCodeFold(false)" />
          <CodeCopy @click="clickCodeCopy" />
        </div>
      </section>

      <section :class="[ns.bem('source')]" :style="`height: ${isCodeFold ? 0 : height}px`">
        <div ref="sourceCodeArea" v-html="showSourceCode" class="language-vue"></div>
      </section>
    </div>
  </ClientOnly>
</template>

<style src="./ant-design.scss"></style>
